package com.gic.udesk.service;

import java.util.List;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.udesk.dto.customfield.UdeskCustomFieldOptionDTO;
import com.gic.udesk.dto.customfield.UdeskResCustomFieldDataDTO;
import com.gic.udesk.dto.templates.UdeskResTemplatesDTO;

public interface UdeskBaseApiService {

    /**
     * 保存udesk类型的异常信息
     * @Title: saveUdeskException 
     * @Description:
      * @author guojuxing
     * @param exceptionRecord 
     * @return  com.gic.api.base.commons.ServiceResponse<java.lang.Void> 
      */
    ServiceResponse<Void> saveUdeskException(String exceptionRecord);
    /**
     * 保存tapd类型的异常信息
     * @Title: saveTapdException 
     * @Description:
      * @author guojuxing
     * @param exceptionRecord 
     * @return  com.gic.api.base.commons.ServiceResponse<java.lang.Void> 
      */
    ServiceResponse<Void> saveTapdException(String exceptionRecord);

    /**
     * 获取工单模板的自定义字段
     * @Title: getCustomFieldFromUdeskTemplates 
     * @Description:
      * @author guojuxing
     * @param type  1：gic基础业务 2：应用
     * @return  com.gic.api.base.commons.ServiceResponse<com.gic.udesk.dto.templates.UdeskResTemplatesDTO> 
      */
    ServiceResponse<List<UdeskResCustomFieldDataDTO>> getCustomFieldFromUdeskTemplates(Integer type);

    ServiceResponse<List<UdeskCustomFieldOptionDTO>> getGicServiceSelect();
}
